/*
 * Copyright (c) 2005-, Claybird
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:

 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the Claybird nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

#include "stdafx.h"
#include "../ArchiverCode/Archiver7ZIP.h"
#include "ConfigManager.h"
#include "Config7Z.h"
#include "../Dialogs/SevenZipVolumeSizeDlg.h"

void CConfig7Z::load(CONFIG_SECTION &Config)
{
	//vZbggǂ
	UsePreset=Config.Data[_T("UsePreset")].GetNParam(TRUE);
	//k`
	CompressType=(SEVEN_ZIP_COMPRESS_TYPE)Config.Data[_T("CompressType")].GetNParam(0,SEVEN_ZIP_COMPRESS_TYPE_LAST_ITEM,0);
	//kx
	CompressLevel=(SEVEN_ZIP_COMPRESS_LEVEL)Config.Data[_T("CompressLevel")].GetNParam(0,SEVEN_ZIP_COMPRESS_LEVEL_LAST_ITEM,0);
	//LZMAk[h
	LZMA_Mode=(SEVEN_ZIP_LZMA_MODE)Config.Data[_T("LZMAMode")].GetNParam(0,SEVEN_ZIP_LZMA_MODE_LAST_ITEM,0);
	//\bhk
	SolidMode=Config.Data[_T("SolidMode")].GetNParam(TRUE);
	//wb_k
	HeaderCompression=Config.Data[_T("HeaderCompression")].GetNParam(TRUE);
	//wb_Sk
	//FullHeaderCompression=Config.Data[_T("HeaderFullCompression")].GetNParam(TRUE);
	//wb_Í
	HeaderEncryption=Config.Data[_T("HeaderEncryption")].GetNParam(FALSE);

	//㋉ݒ
	//PPMd̃fTCYw肷邩ǂ
	SpecifyPPMdModelSize=Config.Data[_T("SpecifyPPMdModelSize")].GetNParam(FALSE);
	//PPMd̃fTCY
	PPMdModelSize=Config.Data[_T("PPMdModelSize")].GetNParam(SEVEN_ZIP_PPMD_MODEL_SIZE_LOWEST,SEVEN_ZIP_PPMD_MODEL_SIZE_HIGHEST,6);

	//TCY炩ߎw
	SpecifySplitSize = Config.Data[_T("SpecifySplitSize")].GetNParam(FALSE);
	SplitSize = Config.Data[_T("SplitSize")].GetNParam(1,INT_MAX,10);
	SplitSizeUnit = Config.Data[_T("SplitSizeUnit")].GetNParam(0,ZIP_VOLUME_UNIT_MAX_NUM,0);
}

void CConfig7Z::store(CONFIG_SECTION &Config)const
{
	//vZbggǂ
	Config.Data[_T("UsePreset")]=UsePreset;
	//k`
	Config.Data[_T("CompressType")]=CompressType;
	//kx
	Config.Data[_T("CompressLevel")]=CompressLevel;
	//LZMAk[h
	Config.Data[_T("LZMAMode")]=LZMA_Mode;
	//\bhk
	Config.Data[_T("SolidMode")]=SolidMode;
	//wb_k
	Config.Data[_T("HeaderCompression")]=HeaderCompression;
	//wb_Sk
	//Config.Data[_T("HeaderFullCompression")]=FullHeaderCompression;
	//wb_Í
	Config.Data[_T("HeaderEncryption")]=HeaderEncryption;

	//㋉ݒ
	//PPMd̃fTCYw肷邩ǂ
	Config.Data[_T("SpecifyPPMdModelSize")]=SpecifyPPMdModelSize;
	//PPMd̃fTCY
	Config.Data[_T("PPMdModelSize")]=PPMdModelSize;

	//TCY炩ߎw
	Config.Data[_T("SpecifySplitSize")] = SpecifySplitSize;
	Config.Data[_T("SplitSize")] = SplitSize;
	Config.Data[_T("SplitSizeUnit")] = SplitSizeUnit;

	// pX[h֘A;݂̓pX[hpR[ĥ
	//w肳ꂽpX[hIɍ폜
	Config.Data.erase(_T("UseFixedPassword"));
	Config.Data.erase(_T("PasswordLength"));
	Config.Data.erase(_T("Password"));
}


void CConfig7Z::load(CConfigManager &ConfMan)
{
	load(ConfMan.GetSection(_T("7Z")));
}

void CConfig7Z::store(CConfigManager &ConfMan)const
{
	store(ConfMan.GetSection(_T("7Z")));
	UtilDumpFlatConfig(ConfMan.GetSection(_T("7Z")).Data);
}

